/* Shortest and possibly fastest Hanoi Tower algorithm.
   Found and then improved by Glenn C. Rhoads;
   then some more by M. Kolar (2000) - see more comments in hBits.c .

   Based on the bits of the move number.
   This version is as hBits.c with the addition of tower visualisation.
   Each tower (peg) represented by the bits of a single integer.
  
   Start post is post 0.
   If # disks even, then final post is post 1, else is post 2
*/

#include <stdio.h>
#include <stdlib.h>

#define PR	(void)printf(

main(int argc, char *argv[])
/*========================*/
{
 int n, fr, to;
 unsigned int x, i, j, p[3];

 n = atoi(argv[1]);

 p[0]=1; p[0]<<=n; p[0]--;
 p[1]=p[2]=0;
 /*
 PR"\n|");
 for(i=n;i>0;i--) PR" %d",i);
 PR"\n|\n|\n");
 */

 for (x=1; x < (1 << n); x++) {

   i=x&x-1; fr=(i+i/3)&3;
   i=(x|x-1)+1; to=(i+i/3)&3;

   for(i=x, j=1; ; i>>=1, j<<=1) { if(i&1) break; }
   /* Now j is not the number of the disk to move,
      it contains the single bit to be moved: */
   p[fr] &= ~j;
   p[to] |= j;

   /*
   PR"\n|"); j=1; j<<=n;
   for(i=n;i>0;i--) { j>>=1; if(j&p[0]) PR" %d",i); }
   PR"\n|"); j=1; j<<=n;
   for(i=n;i>0;i--) { j>>=1; if(j&p[1]) PR" %d",i); }
   PR"\n|"); j=1; j<<=n;
   for(i=n;i>0;i--) { j>>=1; if(j&p[2]) PR" %d",i); }
   PR"\n");
   */

 }

}


/* The original code I got from Glenn:
   -----------------------------------

void main(void)
   {
   int n, x;

   printf( "How many disks? " );
   scanf( "%d", &n );
   puts( "\n\n" );

   for (x=1; x < (1 << n); x++)
      printf( "move from pole %i to pole %i.\n", (x&x-1)%3, ((x|x-1)+1)%3 );
   }
*/
